/**
 * AD.java
 *
 * File generated from the datatypes::AD uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ips.datatypes;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlMixed;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.ips.datatypes.ObjectFactory;
import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class AD.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AD", propOrder = {
	"mixed",
	"isNotOrdered",
	"use"
})
@XmlRootElement(name = "AD")
public class AD extends net.ihe.gazelle.ips.datatypes.ANY implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElementRefs({
			@XmlElementRef(name = "delimiter", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "country", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "state", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "county", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "city", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "postalCode", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "streetAddressLine", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "houseNumber", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "houseNumberNumeric", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "direction", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "streetName", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "streetNameBase", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "streetNameType", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "additionalLocator", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "unitID", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "unitType", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "careOf", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "censusTract", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryAddressLine", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryInstallationType", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryInstallationArea", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryInstallationQualifier", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryMode", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "deliveryModeIdentifier", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "buildingNumberSuffix", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "postBox", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "precinct", namespace = "urn:hl7-org:v3", type = JAXBElement.class),
			@XmlElementRef(name = "useablePeriod", namespace = "urn:hl7-org:v3", type = JAXBElement.class)
		})
		@XmlMixed
	public List<java.io.Serializable> mixed;
	/**
	 *  A boolean value specifying whether the order of the address parts is known or not. While the address parts are always a Sequence, the order in which they are presented may or may not be known. Where this matters, the isNotOrdered property can be used to convey this information. .
	 */
	@XmlAttribute(name = "isNotOrdered")
	public Boolean isNotOrdered;
	/**
	 *  A set of codes advising a system or user which address in a set of like addresses to select for a given purpose. .
	 */
	@XmlAttribute(name = "use")
	public String use;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return mixed.
	 * @return mixed
	 */
	public List<java.io.Serializable> getMixed() {
		if (mixed == null) {
	        mixed = new ArrayList<java.io.Serializable>();
	    }
	    return mixed;
	}
	
	/**
	 * Set a value to attribute mixed.
	 * @param mixed.
	 */
	public void setMixed(List<java.io.Serializable> mixed) {
	    this.mixed = mixed;
	}
	
	
	
	/**
	 * Add a mixed to the mixed collection.
	 * @param mixed_elt Element to add.
	 */
	public void addMixed(java.io.Serializable mixed_elt) {
	    this.getMixed().add(mixed_elt);
	}
	
	/**
	 * Remove a mixed to the mixed collection.
	 * @param mixed_elt Element to remove
	 */
	public void removeMixed(java.io.Serializable mixed_elt) {
	    this.getMixed().remove(mixed_elt);
	}
	
	
	/**
	 * Return delimiter.
	 * @return delimiter
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpDelimiter> getDelimiter() {
		List<net.ihe.gazelle.ips.datatypes.AdxpDelimiter> delimiter_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpDelimiter>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("delimiter")){
					delimiter_el.add( (net.ihe.gazelle.ips.datatypes.AdxpDelimiter) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return delimiter_el;
	}
	
	public void addDelimiter(net.ihe.gazelle.ips.datatypes.AdxpDelimiter obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpDelimiter> jobj = of.createADDelimiter(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return country.
	 * @return country
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpCountry> getCountry() {
		List<net.ihe.gazelle.ips.datatypes.AdxpCountry> country_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpCountry>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("country")){
					country_el.add( (net.ihe.gazelle.ips.datatypes.AdxpCountry) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return country_el;
	}
	
	public void addCountry(net.ihe.gazelle.ips.datatypes.AdxpCountry obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpCountry> jobj = of.createADCountry(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return state.
	 * @return state
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpState> getState() {
		List<net.ihe.gazelle.ips.datatypes.AdxpState> state_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpState>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("state")){
					state_el.add( (net.ihe.gazelle.ips.datatypes.AdxpState) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return state_el;
	}
	
	public void addState(net.ihe.gazelle.ips.datatypes.AdxpState obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpState> jobj = of.createADState(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return county.
	 * @return county
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpCounty> getCounty() {
		List<net.ihe.gazelle.ips.datatypes.AdxpCounty> county_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpCounty>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("county")){
					county_el.add( (net.ihe.gazelle.ips.datatypes.AdxpCounty) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return county_el;
	}
	
	public void addCounty(net.ihe.gazelle.ips.datatypes.AdxpCounty obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpCounty> jobj = of.createADCounty(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return city.
	 * @return city
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpCity> getCity() {
		List<net.ihe.gazelle.ips.datatypes.AdxpCity> city_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpCity>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("city")){
					city_el.add( (net.ihe.gazelle.ips.datatypes.AdxpCity) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return city_el;
	}
	
	public void addCity(net.ihe.gazelle.ips.datatypes.AdxpCity obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpCity> jobj = of.createADCity(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return postalCode.
	 * @return postalCode
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpPostalCode> getPostalCode() {
		List<net.ihe.gazelle.ips.datatypes.AdxpPostalCode> postalCode_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpPostalCode>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("postalCode")){
					postalCode_el.add( (net.ihe.gazelle.ips.datatypes.AdxpPostalCode) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return postalCode_el;
	}
	
	public void addPostalCode(net.ihe.gazelle.ips.datatypes.AdxpPostalCode obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpPostalCode> jobj = of.createADPostalCode(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return streetAddressLine.
	 * @return streetAddressLine
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpStreetAddressLine> getStreetAddressLine() {
		List<net.ihe.gazelle.ips.datatypes.AdxpStreetAddressLine> streetAddressLine_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpStreetAddressLine>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("streetAddressLine")){
					streetAddressLine_el.add( (net.ihe.gazelle.ips.datatypes.AdxpStreetAddressLine) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return streetAddressLine_el;
	}
	
	public void addStreetAddressLine(net.ihe.gazelle.ips.datatypes.AdxpStreetAddressLine obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpStreetAddressLine> jobj = of.createADStreetAddressLine(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return houseNumber.
	 * @return houseNumber
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpHouseNumber> getHouseNumber() {
		List<net.ihe.gazelle.ips.datatypes.AdxpHouseNumber> houseNumber_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpHouseNumber>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("houseNumber")){
					houseNumber_el.add( (net.ihe.gazelle.ips.datatypes.AdxpHouseNumber) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return houseNumber_el;
	}
	
	public void addHouseNumber(net.ihe.gazelle.ips.datatypes.AdxpHouseNumber obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpHouseNumber> jobj = of.createADHouseNumber(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return houseNumberNumeric.
	 * @return houseNumberNumeric
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpHouseNumberNumeric> getHouseNumberNumeric() {
		List<net.ihe.gazelle.ips.datatypes.AdxpHouseNumberNumeric> houseNumberNumeric_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpHouseNumberNumeric>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("houseNumberNumeric")){
					houseNumberNumeric_el.add( (net.ihe.gazelle.ips.datatypes.AdxpHouseNumberNumeric) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return houseNumberNumeric_el;
	}
	
	public void addHouseNumberNumeric(net.ihe.gazelle.ips.datatypes.AdxpHouseNumberNumeric obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpHouseNumberNumeric> jobj = of.createADHouseNumberNumeric(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return direction.
	 * @return direction
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpDirection> getDirection() {
		List<net.ihe.gazelle.ips.datatypes.AdxpDirection> direction_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpDirection>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("direction")){
					direction_el.add( (net.ihe.gazelle.ips.datatypes.AdxpDirection) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return direction_el;
	}
	
	public void addDirection(net.ihe.gazelle.ips.datatypes.AdxpDirection obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpDirection> jobj = of.createADDirection(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return streetName.
	 * @return streetName
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpStreetName> getStreetName() {
		List<net.ihe.gazelle.ips.datatypes.AdxpStreetName> streetName_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpStreetName>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("streetName")){
					streetName_el.add( (net.ihe.gazelle.ips.datatypes.AdxpStreetName) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return streetName_el;
	}
	
	public void addStreetName(net.ihe.gazelle.ips.datatypes.AdxpStreetName obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpStreetName> jobj = of.createADStreetName(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return streetNameBase.
	 * @return streetNameBase
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpStreetNameBase> getStreetNameBase() {
		List<net.ihe.gazelle.ips.datatypes.AdxpStreetNameBase> streetNameBase_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpStreetNameBase>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("streetNameBase")){
					streetNameBase_el.add( (net.ihe.gazelle.ips.datatypes.AdxpStreetNameBase) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return streetNameBase_el;
	}
	
	public void addStreetNameBase(net.ihe.gazelle.ips.datatypes.AdxpStreetNameBase obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpStreetNameBase> jobj = of.createADStreetNameBase(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return streetNameType.
	 * @return streetNameType
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpStreetNameType> getStreetNameType() {
		List<net.ihe.gazelle.ips.datatypes.AdxpStreetNameType> streetNameType_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpStreetNameType>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("streetNameType")){
					streetNameType_el.add( (net.ihe.gazelle.ips.datatypes.AdxpStreetNameType) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return streetNameType_el;
	}
	
	public void addStreetNameType(net.ihe.gazelle.ips.datatypes.AdxpStreetNameType obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpStreetNameType> jobj = of.createADStreetNameType(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return additionalLocator.
	 * @return additionalLocator
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpAdditionalLocator> getAdditionalLocator() {
		List<net.ihe.gazelle.ips.datatypes.AdxpAdditionalLocator> additionalLocator_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpAdditionalLocator>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("additionalLocator")){
					additionalLocator_el.add( (net.ihe.gazelle.ips.datatypes.AdxpAdditionalLocator) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return additionalLocator_el;
	}
	
	public void addAdditionalLocator(net.ihe.gazelle.ips.datatypes.AdxpAdditionalLocator obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpAdditionalLocator> jobj = of.createADAdditionalLocator(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return unitID.
	 * @return unitID
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpUnitID> getUnitID() {
		List<net.ihe.gazelle.ips.datatypes.AdxpUnitID> unitID_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpUnitID>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("unitID")){
					unitID_el.add( (net.ihe.gazelle.ips.datatypes.AdxpUnitID) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return unitID_el;
	}
	
	public void addUnitID(net.ihe.gazelle.ips.datatypes.AdxpUnitID obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpUnitID> jobj = of.createADUnitID(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return unitType.
	 * @return unitType
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpUnitType> getUnitType() {
		List<net.ihe.gazelle.ips.datatypes.AdxpUnitType> unitType_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpUnitType>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("unitType")){
					unitType_el.add( (net.ihe.gazelle.ips.datatypes.AdxpUnitType) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return unitType_el;
	}
	
	public void addUnitType(net.ihe.gazelle.ips.datatypes.AdxpUnitType obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpUnitType> jobj = of.createADUnitType(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return careOf.
	 * @return careOf
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpCareOf> getCareOf() {
		List<net.ihe.gazelle.ips.datatypes.AdxpCareOf> careOf_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpCareOf>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("careOf")){
					careOf_el.add( (net.ihe.gazelle.ips.datatypes.AdxpCareOf) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return careOf_el;
	}
	
	public void addCareOf(net.ihe.gazelle.ips.datatypes.AdxpCareOf obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpCareOf> jobj = of.createADCareOf(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return censusTract.
	 * @return censusTract
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpCensusTract> getCensusTract() {
		List<net.ihe.gazelle.ips.datatypes.AdxpCensusTract> censusTract_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpCensusTract>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("censusTract")){
					censusTract_el.add( (net.ihe.gazelle.ips.datatypes.AdxpCensusTract) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return censusTract_el;
	}
	
	public void addCensusTract(net.ihe.gazelle.ips.datatypes.AdxpCensusTract obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpCensusTract> jobj = of.createADCensusTract(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryAddressLine.
	 * @return deliveryAddressLine
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryAddressLine> getDeliveryAddressLine() {
		List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryAddressLine> deliveryAddressLine_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpDeliveryAddressLine>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryAddressLine")){
					deliveryAddressLine_el.add( (net.ihe.gazelle.ips.datatypes.AdxpDeliveryAddressLine) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryAddressLine_el;
	}
	
	public void addDeliveryAddressLine(net.ihe.gazelle.ips.datatypes.AdxpDeliveryAddressLine obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpDeliveryAddressLine> jobj = of.createADDeliveryAddressLine(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryInstallationType.
	 * @return deliveryInstallationType
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationType> getDeliveryInstallationType() {
		List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationType> deliveryInstallationType_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationType>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryInstallationType")){
					deliveryInstallationType_el.add( (net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationType) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryInstallationType_el;
	}
	
	public void addDeliveryInstallationType(net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationType obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationType> jobj = of.createADDeliveryInstallationType(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryInstallationArea.
	 * @return deliveryInstallationArea
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationArea> getDeliveryInstallationArea() {
		List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationArea> deliveryInstallationArea_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationArea>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryInstallationArea")){
					deliveryInstallationArea_el.add( (net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationArea) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryInstallationArea_el;
	}
	
	public void addDeliveryInstallationArea(net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationArea obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationArea> jobj = of.createADDeliveryInstallationArea(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryInstallationQualifier.
	 * @return deliveryInstallationQualifier
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationQualifier> getDeliveryInstallationQualifier() {
		List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationQualifier> deliveryInstallationQualifier_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationQualifier>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryInstallationQualifier")){
					deliveryInstallationQualifier_el.add( (net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationQualifier) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryInstallationQualifier_el;
	}
	
	public void addDeliveryInstallationQualifier(net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationQualifier obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationQualifier> jobj = of.createADDeliveryInstallationQualifier(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryMode.
	 * @return deliveryMode
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryMode> getDeliveryMode() {
		List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryMode> deliveryMode_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpDeliveryMode>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryMode")){
					deliveryMode_el.add( (net.ihe.gazelle.ips.datatypes.AdxpDeliveryMode) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryMode_el;
	}
	
	public void addDeliveryMode(net.ihe.gazelle.ips.datatypes.AdxpDeliveryMode obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpDeliveryMode> jobj = of.createADDeliveryMode(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return deliveryModeIdentifier.
	 * @return deliveryModeIdentifier
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryModeIdentifier> getDeliveryModeIdentifier() {
		List<net.ihe.gazelle.ips.datatypes.AdxpDeliveryModeIdentifier> deliveryModeIdentifier_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpDeliveryModeIdentifier>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("deliveryModeIdentifier")){
					deliveryModeIdentifier_el.add( (net.ihe.gazelle.ips.datatypes.AdxpDeliveryModeIdentifier) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return deliveryModeIdentifier_el;
	}
	
	public void addDeliveryModeIdentifier(net.ihe.gazelle.ips.datatypes.AdxpDeliveryModeIdentifier obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpDeliveryModeIdentifier> jobj = of.createADDeliveryModeIdentifier(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return buildingNumberSuffix.
	 * @return buildingNumberSuffix
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpBuildingNumberSuffix> getBuildingNumberSuffix() {
		List<net.ihe.gazelle.ips.datatypes.AdxpBuildingNumberSuffix> buildingNumberSuffix_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpBuildingNumberSuffix>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("buildingNumberSuffix")){
					buildingNumberSuffix_el.add( (net.ihe.gazelle.ips.datatypes.AdxpBuildingNumberSuffix) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return buildingNumberSuffix_el;
	}
	
	public void addBuildingNumberSuffix(net.ihe.gazelle.ips.datatypes.AdxpBuildingNumberSuffix obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpBuildingNumberSuffix> jobj = of.createADBuildingNumberSuffix(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return postBox.
	 * @return postBox
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpPostBox> getPostBox() {
		List<net.ihe.gazelle.ips.datatypes.AdxpPostBox> postBox_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpPostBox>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("postBox")){
					postBox_el.add( (net.ihe.gazelle.ips.datatypes.AdxpPostBox) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return postBox_el;
	}
	
	public void addPostBox(net.ihe.gazelle.ips.datatypes.AdxpPostBox obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpPostBox> jobj = of.createADPostBox(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return precinct.
	 * @return precinct
	 */
	public List<net.ihe.gazelle.ips.datatypes.AdxpPrecinct> getPrecinct() {
		List<net.ihe.gazelle.ips.datatypes.AdxpPrecinct> precinct_el = new ArrayList<net.ihe.gazelle.ips.datatypes.AdxpPrecinct>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("precinct")){
					precinct_el.add( (net.ihe.gazelle.ips.datatypes.AdxpPrecinct) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return precinct_el;
	}
	
	public void addPrecinct(net.ihe.gazelle.ips.datatypes.AdxpPrecinct obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.AdxpPrecinct> jobj = of.createADPrecinct(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return useablePeriod.
	 * @return useablePeriod
	 */
	public List<net.ihe.gazelle.ips.datatypes.SXCMTS> getUseablePeriod() {
		List<net.ihe.gazelle.ips.datatypes.SXCMTS> useablePeriod_el = new ArrayList<net.ihe.gazelle.ips.datatypes.SXCMTS>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof JAXBElement){
				if (((JAXBElement<?>)obj).getName().getLocalPart().equals("useablePeriod")){
					useablePeriod_el.add( (net.ihe.gazelle.ips.datatypes.SXCMTS) ((JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return useablePeriod_el;
	}
	
	public void addUseablePeriod(net.ihe.gazelle.ips.datatypes.SXCMTS obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.ips.datatypes.SXCMTS> jobj = of.createADUseablePeriod(obj);
		this.getMixed().add(jobj);
	}
	
	/**
	 * Return isNotOrdered.
	 * @return isNotOrdered :  A boolean value specifying whether the order of the address parts is known or not. While the address parts are always a Sequence, the order in which they are presented may or may not be known. Where this matters, the isNotOrdered property can be used to convey this information. 
	 */
	public Boolean getIsNotOrdered() {
	    return isNotOrdered;
	}
	
	/**
	 * Set a value to attribute isNotOrdered.
	 * @param isNotOrdered :  A boolean value specifying whether the order of the address parts is known or not. While the address parts are always a Sequence, the order in which they are presented may or may not be known. Where this matters, the isNotOrdered property can be used to convey this information. .
	 */
	public void setIsNotOrdered(Boolean isNotOrdered) {
	    this.isNotOrdered = isNotOrdered;
	}
	
	
	/**
	 * Return isNotOrdered.
	 * @return isNotOrdered :  A boolean value specifying whether the order of the address parts is known or not. While the address parts are always a Sequence, the order in which they are presented may or may not be known. Where this matters, the isNotOrdered property can be used to convey this information. 
	 * Generated for the use on jsf pages
	 */
	 @Deprecated
	public Boolean isIsNotOrdered() {
	    return isNotOrdered;
	}
	
	/**
	 * Return use.
	 * @return use :  A set of codes advising a system or user which address in a set of like addresses to select for a given purpose. 
	 */
	public String getUse() {
	    return use;
	}
	
	/**
	 * Set a value to attribute use.
	 * @param use :  A set of codes advising a system or user which address in a set of like addresses to select for a given purpose. .
	 */
	public void setUse(String use) {
	    this.use = use;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.ips.datatypes");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "AD").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	public List<String> getListStringValues(){
		List<String> res = new ArrayList<String>();
		for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof String){
				res.add((String)obj);
			}
		} 
		return res;
	}
	
		

	/**
	 * Description of the method cdaEquals.
	 *
	 * @param addr1
	 * @return ret
	 */
	public Boolean cdaEquals(net.ihe.gazelle.ips.datatypes.AD addr1) {
		Boolean ret = true;
		ret = ret && this.getAdditionalLocator().equals(addr1.getAdditionalLocator());
		ret = ret && this.getBuildingNumberSuffix().equals(addr1.getBuildingNumberSuffix());
		ret = ret && this.getCareOf().equals(addr1.getCareOf());
		ret = ret && this.getCensusTract().equals(addr1.getCensusTract());
		ret = ret && this.getCity().equals(addr1.getCity());
		ret = ret && this.getCountry().equals(addr1.getCountry());
		ret = ret && this.getCounty().equals(addr1.getCounty());
		ret = ret && this.getDelimiter().equals(addr1.getDelimiter());
		ret = ret && this.getDeliveryAddressLine().equals(addr1.getDeliveryAddressLine());
		ret = ret && this.getDeliveryInstallationArea().equals(addr1.getDeliveryInstallationArea());
		ret = ret && this.getDeliveryInstallationQualifier().equals(addr1.getDeliveryInstallationQualifier());
		ret = ret && this.getDeliveryInstallationType().equals(addr1.getDeliveryInstallationType());
		ret = ret && this.getDeliveryMode().equals(addr1.getDeliveryMode());
		ret = ret && this.getDeliveryModeIdentifier().equals(addr1.getDeliveryModeIdentifier());
		ret = ret && this.getDirection().equals(addr1.getDirection());
		ret = ret && this.getHouseNumber().equals(addr1.getHouseNumber());
		ret = ret && this.getHouseNumberNumeric().equals(addr1.getHouseNumberNumeric());
		ret = ret && this.getListStringValues().equals(addr1.getListStringValues());
		return ret;
	}
		

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(AD aD, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (aD != null){
   			net.ihe.gazelle.ips.datatypes.ANY.validateByModule(aD, _location, cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpDelimiter delimiter: aD.getDelimiter()){
					net.ihe.gazelle.ips.datatypes.AdxpDelimiter.validateByModule(delimiter, _location + "/delimiter[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpCountry country: aD.getCountry()){
					net.ihe.gazelle.ips.datatypes.AdxpCountry.validateByModule(country, _location + "/country[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpState state: aD.getState()){
					net.ihe.gazelle.ips.datatypes.AdxpState.validateByModule(state, _location + "/state[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpCounty county: aD.getCounty()){
					net.ihe.gazelle.ips.datatypes.AdxpCounty.validateByModule(county, _location + "/county[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpCity city: aD.getCity()){
					net.ihe.gazelle.ips.datatypes.AdxpCity.validateByModule(city, _location + "/city[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpPostalCode postalCode: aD.getPostalCode()){
					net.ihe.gazelle.ips.datatypes.AdxpPostalCode.validateByModule(postalCode, _location + "/postalCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpStreetAddressLine streetAddressLine: aD.getStreetAddressLine()){
					net.ihe.gazelle.ips.datatypes.AdxpStreetAddressLine.validateByModule(streetAddressLine, _location + "/streetAddressLine[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpHouseNumber houseNumber: aD.getHouseNumber()){
					net.ihe.gazelle.ips.datatypes.AdxpHouseNumber.validateByModule(houseNumber, _location + "/houseNumber[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpHouseNumberNumeric houseNumberNumeric: aD.getHouseNumberNumeric()){
					net.ihe.gazelle.ips.datatypes.AdxpHouseNumberNumeric.validateByModule(houseNumberNumeric, _location + "/houseNumberNumeric[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpDirection direction: aD.getDirection()){
					net.ihe.gazelle.ips.datatypes.AdxpDirection.validateByModule(direction, _location + "/direction[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpStreetName streetName: aD.getStreetName()){
					net.ihe.gazelle.ips.datatypes.AdxpStreetName.validateByModule(streetName, _location + "/streetName[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpStreetNameBase streetNameBase: aD.getStreetNameBase()){
					net.ihe.gazelle.ips.datatypes.AdxpStreetNameBase.validateByModule(streetNameBase, _location + "/streetNameBase[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpStreetNameType streetNameType: aD.getStreetNameType()){
					net.ihe.gazelle.ips.datatypes.AdxpStreetNameType.validateByModule(streetNameType, _location + "/streetNameType[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpAdditionalLocator additionalLocator: aD.getAdditionalLocator()){
					net.ihe.gazelle.ips.datatypes.AdxpAdditionalLocator.validateByModule(additionalLocator, _location + "/additionalLocator[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpUnitID unitID: aD.getUnitID()){
					net.ihe.gazelle.ips.datatypes.AdxpUnitID.validateByModule(unitID, _location + "/unitID[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpUnitType unitType: aD.getUnitType()){
					net.ihe.gazelle.ips.datatypes.AdxpUnitType.validateByModule(unitType, _location + "/unitType[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpCareOf careOf: aD.getCareOf()){
					net.ihe.gazelle.ips.datatypes.AdxpCareOf.validateByModule(careOf, _location + "/careOf[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpCensusTract censusTract: aD.getCensusTract()){
					net.ihe.gazelle.ips.datatypes.AdxpCensusTract.validateByModule(censusTract, _location + "/censusTract[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpDeliveryAddressLine deliveryAddressLine: aD.getDeliveryAddressLine()){
					net.ihe.gazelle.ips.datatypes.AdxpDeliveryAddressLine.validateByModule(deliveryAddressLine, _location + "/deliveryAddressLine[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationType deliveryInstallationType: aD.getDeliveryInstallationType()){
					net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationType.validateByModule(deliveryInstallationType, _location + "/deliveryInstallationType[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationArea deliveryInstallationArea: aD.getDeliveryInstallationArea()){
					net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationArea.validateByModule(deliveryInstallationArea, _location + "/deliveryInstallationArea[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationQualifier deliveryInstallationQualifier: aD.getDeliveryInstallationQualifier()){
					net.ihe.gazelle.ips.datatypes.AdxpDeliveryInstallationQualifier.validateByModule(deliveryInstallationQualifier, _location + "/deliveryInstallationQualifier[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpDeliveryMode deliveryMode: aD.getDeliveryMode()){
					net.ihe.gazelle.ips.datatypes.AdxpDeliveryMode.validateByModule(deliveryMode, _location + "/deliveryMode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpDeliveryModeIdentifier deliveryModeIdentifier: aD.getDeliveryModeIdentifier()){
					net.ihe.gazelle.ips.datatypes.AdxpDeliveryModeIdentifier.validateByModule(deliveryModeIdentifier, _location + "/deliveryModeIdentifier[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpBuildingNumberSuffix buildingNumberSuffix: aD.getBuildingNumberSuffix()){
					net.ihe.gazelle.ips.datatypes.AdxpBuildingNumberSuffix.validateByModule(buildingNumberSuffix, _location + "/buildingNumberSuffix[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpPostBox postBox: aD.getPostBox()){
					net.ihe.gazelle.ips.datatypes.AdxpPostBox.validateByModule(postBox, _location + "/postBox[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.AdxpPrecinct precinct: aD.getPrecinct()){
					net.ihe.gazelle.ips.datatypes.AdxpPrecinct.validateByModule(precinct, _location + "/precinct[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.SXCMTS useablePeriod: aD.getUseablePeriod()){
					net.ihe.gazelle.ips.datatypes.SXCMTS.validateByModule(useablePeriod, _location + "/useablePeriod[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

	@Override
	public String toString() {
		return "AD [city=" + getCity() +  "]";
	}
   
//   
   
   
   

}